Page MenuHomePhabricator

Allow customization of forms for Workboards
Closed, WontfixPublic

Description

Would like to create a simpler "Create Task" form for our Workboards.

The deeper issue (which is already discussed in T6064 for example) is that Workboards are currently too complex for the purpose of quickly adding tasks and changing their titles, partly because they default to the "full" edit/create forms from Maniphest. Below are some examples from Trello:

"Create task" link

Simple "Create" form

Simple "Edit" form

Event Timeline

venky created this task.Aug 15 2016, 11:55 PM

Why does having more fields make creating a task slower? I'm not able to create tasks any more quickly using a form with fewer fields.

More fields means

  • more <tab>s (or more point-and-clicks) to find the field you want to edit
  • more cognitive load to parse the entry form

We use these Trello boards in prioritization meetings where the board is up on the screen, people are going around the room giving updates, and one person is editing the board in response to "that's done", "let's close that one and make another one for the remaining work". Most of the other detail on the task is filled in later, by someone who picks it up. Trello makes this easy by requiring "Add a card" -> "type title" -> Enter or "click into card" -> edit -> Enter.

Technically the Workboards flow isn't much worse: "dropdown" -> "create task" -> "type title" (cursor is already in Title field) -> Enter. However the combination of the 2-step entry into the form, the form opening up in a dialog (taking everyone's attention away from the rest of the board), and the form being many more fields means that it feels a lot heavier.

It sounds like you really want Workboards to work exactly like Trello, not just to be able to customize the form? That is, if we let you simplify the form down to this:

...it would still obscure the board and presumably "feel heavy". Is this really "Make Workboards look and feel exactly like Trello"?

Is this really "Make Workboards look and feel exactly like Trello"?

the combination of the 2-step entry into the form, the form opening up in a dialog (taking everyone's attention away from the rest of the board), and the form being many more fields

In this task I was initially focusing on the third of the above complaints (also I happened to just figure out how to do this for Maniphest, but couldn't do it for Workboards). T6064 already talks about the first one. Forcing me to think about why it felt worse led me to the second complaint. Inline editing like Trello would address all three simultaneously, and would be a nice feature to adopt from Trello.

There is no actual cost to the form having more fields though, right? It doesn't actually slow you down, it just "feels" more complex?

You don't need to spend more actions interacting with the form if you're only editing the title, since it's default-focused and you can ignore the rest of the form. If you're using the keyboard, you can press "enter" to save the form immediately and don't need to press tab.

If you're editing any other field, having all the fields available is much faster than Trello's approach, right? For example, Trello appears to require more clicks to change the assignee and changing the assignee with the keyboard appears to be impossible. And if you want to create a task with an assignee, you have to click, type, save, click to edit, click "Change Members"? Maybe there's some shortcut for this?

I agree that there *shouldn't* be any extra cost purely owing to having more fields if I'm only editing one and it is default-focused, but I'd argue that having a more complex form will still slow humans down (at least initially).

Trello allows you to click on a card and open it up in the "full" mode as well, so you can slip into editing multiple fields with about equal facileness as Workboards (you can try a part of this on https://trello.com/b/nC8QJJoZ/trello-development-roadmap). This dialog also serves the same purpose as T10469, since they allow clicking on any text and editing it.

However, as mentioned above, we tend to use the "simple" editing mode much more during our prioritization meetings, and we don't end up needing a lot of the other fields at that time.

Would this apply to having ability to set an edit/create task template as default for a workboard/project? This recently came up in discussion the other day where someone wanted tasks made for a workboard/project auto-inherited permissions. My mind turned to making a new Create task template with the permissions they wanted, but it didn't seem there was a way to set it default to a project. It sounds like this task touches on similar area?

venky added a comment.Aug 25 2016, 9:06 PM

A potentially less controversial fix for the 2-step entry issue might be to add a keyboard shortcut that will add a task to the last used column.

epriestley closed this task as Wontfix.Sep 2 2016, 10:38 PM
epriestley claimed this task.
  • T6064 already covers creating tasks with one click instead of two.
  • T10946 covers using EditEngine templates on workboards, I guess. That task is pretty iffy, too. This could probably use a separate, more focused task -- @cspeckmim, if you want to file one describing your use case in a little more detail I can merge T10946 into it if I don't have better ideas for you. (I thought I saw one more of these somewhere while dredging through the backlog to populate Contributor Onboarding but I wasn't immediately able to find it.)
  • We don't currently plan to implement a distinct inline quick edit mode like Trello.